﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication6
{
    public partial class Form1 : Form
    {
        private Button[,] pexesa;

        public Form1()
        {
            InitializeComponent();

            tableLayoutPanel1.SetColumnSpan(button2, 2);
        }

        private void rozdejToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pexesa = new Button[4, 4];
            pnlDesktop.Controls.Clear();

            IList<Color> pexesoColors = new List<Color>() {
                Color.Red,
                Color.Lime,
                Color.Blue,
                Color.Yellow,
                Color.Magenta,
                Color.Black,
                Color.Brown,
                Color.Cyan
            };
            for (int i = 0; i < 8; i++)
            {
                pexesoColors.Add(pexesoColors[i]);
            }

            Random r = new Random();
            for (int top = 0; top < pexesa.GetLength(1); top++)
            {
                for (int left = 0; left < pexesa.GetLength(0); left++)
                {
                    Button btn = new Button();
                    btn.Text = string.Format("{0};{1}", left, top);
                    btn.Left = (int)(left * (pnlDesktop.Width / (float)pexesa.GetLength(0)));
                    btn.Top = (int)(top * (pnlDesktop.Height / (float)pexesa.GetLength(1)));
                    btn.Width = (int)(pnlDesktop.Width / (float)pexesa.GetLength(0));
                    btn.Height = (int)(pnlDesktop.Height / (float)pexesa.GetLength(1));
                    btn.Click += btn_Click;

                    int colorIndex = r.Next(0, pexesoColors.Count - 1);
                    btn.Tag = pexesoColors[colorIndex];
                    btn.ForeColor = pexesoColors[colorIndex];

                    pexesoColors.RemoveAt(colorIndex);

                    pnlDesktop.Controls.Add(btn);
                    pexesa[left, top] = btn;
                }
            }
        }

        private int pocetOtocenychPexes = 0;
        private Button otocenePexeso1;
        private Button otocenePexeso2;
        private int points = 0;

        void btn_Click(object sender, EventArgs e)
        {
            if (pocetOtocenychPexes < 2)
            {
                Button btn = (Button)sender;
                btn.BackColor = (Color)btn.Tag;
                if (pocetOtocenychPexes == 0)
                {
                    otocenePexeso1 = btn;
                    pocetOtocenychPexes++;
                }
                else if (pocetOtocenychPexes == 1)
                {
                    otocenePexeso2 = btn;

                    if (otocenePexeso1.BackColor == otocenePexeso2.BackColor)
                    {
                        otocenePexeso1.Visible = false;
                        otocenePexeso2.Visible = false;
                        pocetOtocenychPexes = 0;
                        points += 1;
                        Text = "Počet bodů: " + points;

                        if (points == pnlDesktop.Controls.Count / 2)
                        {
                            MessageBox.Show("Vítězství");
                        }
                    }
                    else
                    {
                        timer1.Start();
                        pocetOtocenychPexes++;
                    }
                }
            }
            else
            {
                OtocitPexesoZpet();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            OtocitPexesoZpet();
        }

        private void OtocitPexesoZpet()
        {
            pocetOtocenychPexes = 0;
            if (otocenePexeso1 != null)
                otocenePexeso1.UseVisualStyleBackColor = true;
            if (otocenePexeso2 != null)
                otocenePexeso2.UseVisualStyleBackColor = true;
            timer1.Stop();
        }
    }
}
